/**
 *  gracket-font-fix.cpp
 */

#include "stdafx.h"

void ApplyPatchToAllDllsInLibDir(void);
bool ApplyPatchToDll(LPCTSTR dllPath);
size_t FileHasCodeSignature(FILE* file, BYTE* sigTable, size_t sigLen);
void FileBackup(LPCTSTR fileName);

/**
 *	CGg
 */
int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	// lib tH_ׂ̂Ă DLL 񋓂ăpb`Kp
	ApplyPatchToAllDllsInLibDir();

	return 0;
}


/**
 *	 exe t@C̃fBNgԂ܂B
 */
LPCTSTR GetExeDir(void) 
{
	static TCHAR s_exeDir[MAX_PATH] = {0};

	if (s_exeDir[0] == _T('\0')) {
		GetModuleFileName(NULL, s_exeDir, MAX_PATH);
		for (int pos = lstrlen(s_exeDir) -1; pos >= 0; pos--) {
			if (s_exeDir[pos] == _T('\\')) {
				s_exeDir[pos] = _T('\0');
				break;
			}
		}
	}

	return s_exeDir;
}


/**
 *	 str1  str2 ŏIĂ邩𔻒肵܂B
 *	召ʂ܂B
 */
bool StringEndsWidthI(LPCTSTR str1, LPCTSTR str2) 
{
	int len1 = lstrlen(str1);
	int len2 = lstrlen(str2);
	if (len1 >= len2) {
		return (0 == lstrcmpi(str1 + (len1 - len2), str2));
	}
	return false;
}


/**
 *	lib fBNĝׂĂ DLL ɑ΂ăpb`Kp܂B
 */
void ApplyPatchToAllDllsInLibDir() 
{
	//  exe t@C̃fBNg̃pX擾
	LPCTSTR exeDir = GetExeDir();

	// lib fBNg̃pX擾
	TCHAR libDir[MAX_PATH];
	lstrcpy(libDir, exeDir);
	lstrcat(libDir, _T("\\lib"));

	TCHAR libDirFiles[MAX_PATH];
	lstrcpy(libDirFiles, libDir);
	lstrcat(libDirFiles, _T("\\*.dll"));

	// lib fBNĝׂĂ DLL 񋓂
	WIN32_FIND_DATA findData = {0};
	HANDLE findHandle = FindFirstFile(libDirFiles, &findData);
	if (findHandle == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, _T("̃pb` Racket ̃CXg[ fBNgɃRs[ŎsĂB"), _T("G["), MB_OK | MB_ICONERROR);
		return;
	}

	bool patchApplied = false;

	// t@C񋓂
	do {
		// TufBNg͏O
		if ((findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0) continue;

		// gq .dll ̏ꍇ
		if (StringEndsWidthI(findData.cFileName, _T(".dll"))) {
			TCHAR dllPath[MAX_PATH];
			lstrcpy(dllPath, libDir);
			lstrcat(dllPath, _T("\\"));
			lstrcat(dllPath, findData.cFileName);
			if (ApplyPatchToDll(dllPath)) {
				patchApplied = true;
			}
		}
	}
	while(FindNextFile(findHandle, &findData));

	// nh
	FindClose(findHandle);

	// pb`̓KpʂbZ[Wŕ\
	if (patchApplied) {
		MessageBox(NULL, _T("pb`Kp܂B"), _T(""), MB_OK | MB_ICONINFORMATION);
	}
	else {
		MessageBox(NULL, _T("pb`Kpł܂B"), _T("s"), MB_OK | MB_ICONERROR);
	}
}


/**
 *	MrEd ̏CׂR[h̃VOj``܂B
 */
#define ANY_  0xCC
static const BYTE s_target_signature[] = {
	0x55,										// PUSH EBP
	0x8B, 0xEC,									// MOV EBP,ESP
	0x83, 0xEC, ANY_,							// SUB ESP,38
	0x53,										// PUSH EBX
	0x8B, 0xD8,									// MOV EBX,EAX
	0xFF, 0x15, ANY_, ANY_, ANY_, ANY_,			// CALL DWORD PTR DS:[<&libracket3m_89os0g.>
	0x8B, 0x00,									// MOV EAX,DWORD PTR DS:[EAX]
	0x89, 0x45, ANY_,							// MOV DWORD PTR SS:[EBP-38],EAX
	0xFF, 0x15, ANY_, ANY_, ANY_, ANY_,			// CALL DWORD PTR DS:[<&libracket3m_89os0g.>
	0x83, 0xFB, ANY_,							// CMP EBX,1
	0x8D, 0x4D, ANY_,							// LEA ECX,DWORD PTR SS:[EBP-38]
	0x89, 0x08,									// MOV DWORD PTR DS:[EAX],ECX
	0x8D, 0x55, ANY_,							// LEA EDX,DWORD PTR SS:[EBP+10]
	0x89, 0x55, ANY_,							// MOV DWORD PTR SS:[EBP-30],EDX
	0x8D, 0x45, ANY_,							// LEA EAX,DWORD PTR SS:[EBP+14]
	0x8D, 0x4D, ANY_,							// LEA ECX,DWORD PTR SS:[EBP+C]
	0x8D, 0x55, ANY_,							// LEA EDX,DWORD PTR SS:[EBP+8]
	0x89, 0x45, ANY_,							// MOV DWORD PTR SS:[EBP-2C],EAX
	0x89, 0x4D, ANY_,							// MOV DWORD PTR SS:[EBP-28],ECX
	0x89, 0x55, ANY_,							// MOV DWORD PTR SS:[EBP-24],EDX
	0x0F, 0x85, ANY_, ANY_, ANY_, ANY_,			// JNZ libgrack.909E214A

	// ̍Ō JNZ ߂ JMP ߂ɏ΂悢B
	// ܂A0x0F, 0x85,  0x90, 0xE9 Ƃ΂悢B
};

static const size_t s_target_signature_size = sizeof(s_target_signature) / sizeof(s_target_signature[0]);


/**
 *	w肳ꂽ DLL Ƀpb`Kp܂B
 *	Kpɐ trueAs false Ԃ܂B
 */
bool ApplyPatchToDll(LPCTSTR dllPath) 
{
	// DLL ǂݎ胂[hŊJ
	FILE* file = _tfopen(dllPath, _T("rb"));
	if (file == NULL) return false;

	// ̃t@CCΏۃR[h̃VOj`ǂ肷
	size_t targetPos = FileHasCodeSignature(file, (BYTE*) s_target_signature, s_target_signature_size);

	// t@C
	fclose(file);
	file = NULL;

	// VOj`݂ȂȂ牽Ȃ
	if (targetPos == -1) return false;

	// DLL ̃obNAbv
	FileBackup(dllPath);

	// DLL ǂݏ[hōēxJ
	file = _tfopen(dllPath, _T("r+b"));
	if (file == NULL) return false;

	// R[h
	BYTE modifyCode[2] = { 0x90, 0xE9 };
	fseek(file, targetPos + s_target_signature_size - 6, SEEK_SET );
	fwrite(modifyCode, 1, 2, file);

	// t@C
	fclose(file);
	file = NULL;

	return true;
}


/**
 *	w肳ꂽt@C̃VOj`肵܂B
 */
size_t FileHasCodeSignature(FILE* file, BYTE* sigTable, size_t sigLen) 
{
	fseek(file, 0, SEEK_SET);

	size_t codeCount = 0;
	size_t codePos = 0;
	int sigIndex = 0;
	while (1) {
		BYTE code;

		// R[hPǂ݂Ƃ
		if (0 == fread(&code, 1, 1, file)) break;
		codeCount++;

		// R[hChJ[hAVOj`R[hɈvꍇ
		if (sigTable[sigIndex] == ANY_ || sigTable[sigIndex] == code) {
			sigIndex++;
			if (sigIndex == sigLen) return codePos;
		}
		else {
			// VOj`̃}b`CfbNX 0 ɃZbg
			codePos = codeCount;
			sigIndex = 0;
		}
	}
	return -1;
}


/**
 *	t@C̃obNAbv܂B
 */
void FileBackup(LPCTSTR fileName)
{
	TCHAR backupFile[MAX_PATH];

	// ݂Ȃt@C쐬ł܂Ń[vJԂB
	// [vɂȂȂ悤ɁA[v񐔂ɐ݂Ă
	for (int index = 0; index < 999; index++) {

		// obNAbv t@C쐬
		lstrcpy(backupFile, fileName);
		lstrcat(backupFile, _T(".backup"));
		if (index != 0) {
			TCHAR suffix[32];
			_stprintf(suffix, _T(".%d"), index);
			lstrcat(backupFile, suffix);
		}

		// t@C݂Ȃ΁A[vI
		if (INVALID_FILE_ATTRIBUTES == GetFileAttributes(backupFile)) break;
	}

	// t@CRs[
	CopyFile(fileName, backupFile, TRUE);
}

